#include <iostream>
#include <windows.h>

#pragma comment (lib, "winmm.lib") 

typedef void (*pA100CallBackFunc)(unsigned char, unsigned char, unsigned char, unsigned char, unsigned char, unsigned char, unsigned char*, int);

int send_start_time = 0;

/******************************************************************
       A100DLL  " ".         
******************************************************************/
bool (*pA100UIntToData)(const unsigned int arg_val, unsigned char data_arr[4]);

unsigned int (*pA100DataToUInt)(const unsigned char data_arr[4]);

bool (*pA100FloatToData)(const float arg_val, unsigned char float_point_count, unsigned char data_arr[4]);

float (*pA100DataToFloat)(const unsigned char data_arr[4]);

bool (*pA100OpenSerialPort)(const std::string &interface_name, const int &interface_speed);

int (*pA100GetSerialPortCurrentState)();

void (*pA100CloseSerialPort)();

int (*pA100SendCommand)(unsigned char receiver_address, unsigned char sender_address, unsigned char command_code, unsigned char command_param, unsigned char data_array[4], int write_timeout, int read_timeout, pA100CallBackFunc a100CallBackFunc, bool b_wait);


/******************************************************************
 
******************************************************************/
void a100CallBackFunc (unsigned char dest, unsigned char source, unsigned char code, unsigned char param, unsigned char status, unsigned char error, unsigned char data[4], int error_status)
{
	std::cerr<<"\n elapsed send-receive time = "<<timeGetTime() - send_start_time<<" ms";	
	std::cerr<<"\n error_status = "<<error_status<<"\n";

	std::cerr<<"\n dest = "<<(int)(dest & 127);
	std::cerr<<"\n source = "<<(int)source;
	std::cerr<<"\n code = "<<(int)code;
	std::cerr<<"\n param = "<<(int)param;
	std::cerr<<"\n status = "<<(int)status;
	std::cerr<<"\n error = "<<(int)error;
	std::cerr<<"\n UINT data = "<<pA100DataToUInt(data);
	std::cerr<<"\n FLOAT data = "<<pA100DataToFloat(data);
}

/******************************************************************
MAIN
******************************************************************/
int main()
{
	timeBeginPeriod(1);
	Sleep(1000);
	
	HMODULE runTimeDLLHandle = LoadLibrary(TEXT("A100DLL.dll"));

	if(runTimeDLLHandle == NULL)
	{
	    MessageBox(NULL, TEXT("Failed to load the DLL"), TEXT("Error"), MB_OK );		
	} 
	else
		{
			(FARPROC &)pA100UIntToData = GetProcAddress(runTimeDLLHandle, "a100UIntToData");

			(FARPROC &)pA100DataToUInt = GetProcAddress(runTimeDLLHandle, "a100DataToUInt");
			
			(FARPROC &)pA100FloatToData = GetProcAddress(runTimeDLLHandle, "a100FloatToData");
			
			(FARPROC &)pA100DataToFloat = GetProcAddress(runTimeDLLHandle, "a100DataToFloat");
			
			(FARPROC &)pA100OpenSerialPort = GetProcAddress(runTimeDLLHandle, "a100OpenSerialPort");
			
			(FARPROC &)pA100GetSerialPortCurrentState = GetProcAddress(runTimeDLLHandle, "a100GetSerialPortCurrentState");
			
			(FARPROC &)pA100CloseSerialPort = GetProcAddress(runTimeDLLHandle, "a100CloseSerialPort");
			
			(FARPROC &)pA100SendCommand = GetProcAddress(runTimeDLLHandle, "a100SendCommand");

			if((!pA100UIntToData) || (!pA100DataToUInt) || (!pA100FloatToData) || (!pA100DataToFloat) || (!pA100OpenSerialPort) || (!pA100GetSerialPortCurrentState) || (!pA100CloseSerialPort) || (!pA100SendCommand))
			{
				MessageBox(NULL, TEXT("A100DLL functions load error !!!"),TEXT("Error"), MB_OK );
				FreeLibrary(runTimeDLLHandle);
				timeEndPeriod(1);
				return 0 ;
			}

			unsigned char data_array[4] = {0, 0, 0, 0};
			int time_out = 100;

			int cur_state;

			if (pA100OpenSerialPort("COM1", 38400))
			{
				cur_state = pA100GetSerialPortCurrentState();

				send_start_time = timeGetTime();
				pA100SendCommand(0x01, 0x1f, 0x00, 0x00, data_array, time_out, time_out, a100CallBackFunc, true);
			
				//    pA100SendCommand   false    
				//    /  .
				//         ..    
				//      
				
				/*do
				{ 
					Sleep(1);
					cur_state = pA100GetSerialPortCurrentState();
				} while ((cur_state != 1) && (cur_state != 0));*/
			
				std::cerr<<"\n";

				send_start_time = timeGetTime();
				pA100SendCommand(0x01, 0x1f, 0x03, 0x00, data_array, time_out, time_out, a100CallBackFunc, true);
			}
		
			std::cin.get();
			pA100CloseSerialPort();
			FreeLibrary(runTimeDLLHandle);
	}
	
	timeEndPeriod(1);
	return 0;
}
